<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.5.01  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@hccnet.nl)
* Core function:
* filemanager.inc.php: last changed 15/06/2007 by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* Multiple file upload applet postlet used is from http://sourceforge.net/projects/postlet/
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}
if (IsSet ($_GET['suboption']))
{
	$suboption = $_GET['suboption'];
}
else
{
$suboption = "file_list" ;
}
if (IsSet ($_POST['newdirectory']))
{
	$newdirectory = $_POST['newdirectory'];
}
if (IsSet ($_POST['subpath']))
{
	$subpath = $_POST['subpath'];
}
if (IsSet ($_GET['file']))
{
$delete_list[0] = $_GET['file'] ; //just one file to delete put it as single in an array
}
if (IsSet ($_POST['delete_list']))
{
	$delete_list = $_POST['delete_list'];
}
if (IsSet ($_GET['path']))
{
	$path = $_GET['path'];
}
// type can be "media_dir" , "studentpages" and  "classes" 
if (IsSet ($_GET['type']))
{
	$type = $_GET['type'];
}
else
{
	$type = "media_dir" ;	//default choice list the media dir.
	//$suboption = "file_list" ;
}
if (($type == "classes") OR ($type == "student_dir"))
{
	$rootpath = "studentpages";
}
else
{
$rootpath = $media;
}
if (IsSet ($_GET['delete_dir']))
{
	$delete_dir = $_GET['delete_dir'];
}

if (IsSet ($_GET['class']))
{
	$class = $_GET['class'];
}

/* get a list of the files + dirs and turn the list into an array */
function file_list($dir)
{
	//  global $sort;
	global $file_file_count;
	if (is_dir($dir))
	{
		$fd = @ opendir($dir);
		while (($part = @ readdir($fd)) == true)
		{
			clearstatcache();
			if ($part != "." && $part != "..")
			{
				$file_array[] = $part;
			}
		}

		if ($fd == true)
		{
			closedir($fd);
		}

		if (is_array($file_array))
		{
			//order the files naterually
			$array_lowercase = array_map('strtolower', $file_array); //convert to lowercase first
			array_multisort($array_lowercase, SORT_ASC, SORT_REGULAR, $file_array); //do the sorting
			$file_file_count = count($file_array);
			return $file_array;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}
}

/* function to convert to Mb, Kb and bytes */
function file_size($size)
{
	$megabyte = 1024 * 1024;
	if ($size > $megabyte)
	{ /* literal.float */
		$re_sized = sprintf("%01.2f", $size / $megabyte) . " Mb";
	}
	elseif ($size > 1024)
	{
		$re_sized = sprintf("%01.2f", $size / 1024) . " Kb";
	}
	else
	{
		$re_sized = $size . " bytes";
	}
	return $re_sized;
}

/* get a list of the files/dirs, put them into a table. */
function generate_file_list($path)
{
	global $full_path;
	global $sas_lang;
	global $media;
	global $rootpath;
	global $table_pages;
	global $table_sections;
	global $suboption;
	global $class, $type;
	$final_path = str_replace("//", "/", str_replace("..", "", urldecode($path)));
	$file_array = file_list("$full_path/$final_path/");
	$bgcolor = "E7E7EF";
	echo "<br>\n";

	if ($file_array == true) /* check if the dir is an array before we process it to foreach(); */
	{
		$file_count = count_files_dirs("$full_path/$final_path/") ;
		if ($file_count[1] > 0) //do we have files in this directory, if yes display table header
		{
		print "<table width=\"90%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
				  <tr><td colspan=\"3\">&nbsp;</td>
				  <td><span class=\"text\"><b>" . $sas_lang['file'] . "</b></span></td>         
				  <td><span class=\"text\"><b>" . $sas_lang['filesize'] . "</b></span></td>";
		}
		//we only want a location button for the media directory
		if ($rootpath == "$media")
		{
			print "<td><span class=\"text\"><b>" . $sas_lang['section'] . " -> " . $sas_lang['category'] . " -> " . $sas_lang['page'] . ":</b></span></td>
					 <td><form method=post action=index.php?option=filemanager&path=$path&suboption=check_files>
					 <input type=submit value=\"" . $sas_lang['location'] . "\"></a></form></td></tr>\n";
		}
		$i = 0;
		print "\n<FORM METHOD=\"POST\" ACTION=\"index.php?option=filemanager&suboption=delete&type=$type&path=$path&class=$class\">";
		foreach ($file_array as $file_name)
		{
			$is_file = "$full_path/$final_path/$file_name";
			$final_dir_name = urlencode($final_path); /* urlencode(); to prevent any broken links - decode on do_download(); */
			$final_file_name = urlencode($file_name);
			$file_size = filesize("$full_path/$final_path/$file_name");
			$final_file_size = file_size($file_size);
			$page_name = "&nbsp;";

			if ($suboption == "check_files")
			{
				$query = "SELECT section, name, category FROM $table_pages WHERE content like '%$final_path/$file_name%'"; //see if picture is used in S@S
				$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
				$num_rows = mysql_num_rows($result);
				if ($num_rows > 0)
				{
					$row = mysql_fetch_array($result);
					$query2 = "SELECT name FROM $table_sections WHERE id='$row[section]'"; //get the section name
					$result2 = mysql_query($query2) or trigger_error(mysql_error().'"<br>Query : "' . $query2 . '".',E_USER_WARNING); 
					$section_name = mysql_result($result2, 0);
					if ($row[category] != "")
					{
						$page_name = "$section_name -> $row[category] -> $row[name]";
					}
					else
					{
						$page_name = "$section_name -> $row[name]";
					}
				}
				else
				{
					$page_name = " -  -  -"; //blank page name
				}
			}

			if (is_file($is_file))
			{
				$file_date = date("d-m-Y", filemtime("$full_path/$final_path/$file_name"));
				$delete_file_confirmation = str_replace("%object%", $file_name, $sas_lang['delete_file_confirmation']);

				print "<tr bgcolor=\"$bgcolor\"><td width=\"18\" height=\"18\">
						<INPUT type=\"checkbox\" name=\"delete_list[$i]\" value=\"$final_file_name\"></td>";
				print "<td width=\"18\" height=\"18\">
						<img border=\"0\" src=\"graphics/delete.gif\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\" width=\"16\" height=\"16\" 
						onClick=\"if(confirm('" . $delete_file_confirmation . "')) 
						parent.location='index.php?option=filemanager&type=$type&suboption=delete&file=$final_file_name&class=$class&path=$path';\"></td>";
				print "<td width=18 height=18><img border=\"0\" src=\"graphics/document.gif\" width=\"16\" height=\"16\"></td>
						<td><span class=\"text\"><a href=\"$rootpath$final_path/$final_file_name\" target=\"_blank\">$file_name</a></span></td>
						<td><span class=\"text\">$file_date ($final_file_size)&nbsp;</span></td>
						<td colspan=\"2\"><span class=\"text\">$page_name</span></td></tr>\n";
				$i++ ;
				if ($bgcolor == "#FFFFFF")
				{
					$bgcolor = "#E7E7EF";
				}
				else
				{
					$bgcolor = "#FFFFFF";
				}
			}
		}
		//if $i > 0 we have files in the directory, so we create the delete button.
		if ($i > 0)
		{
?>
<script language='javascript'>
    function checkUncheckAll(theElement)
    {
	 //documentation for this script at http://www.shawnolson.net/a/693/
     var theForm = theElement.form, z = 0;
		while (theForm[z].type == 'checkbox' && theForm[z].name != 'checkall') 
		{
		theForm[z].checked = theElement.checked;
		z++;
		}
    }
</script>
<?php

print "<tr><td colspan=\"7\">&nbsp;</td></tr>
		<tr><td align=\"center\"><input type=\"checkbox\" name=\"checkall\"
          onclick=\"checkUncheckAll(this);\"/></td><td colspan=\"6\"><span class=\"text\">".$sas_lang['select_all']."&nbsp;</span>		  
		&nbsp;<input type=\"submit\" value=\"" . $sas_lang['delete'] . "\" name=\"savebutton\"></td></tr>";
		echo "</table></form>\n";
		}
	}
}//end of generate_file_list() function

function generate_dir_list($path)
{
	global $full_path;
	global $sas_lang, $table_users, $table_classes;
	global $rootpath;
	global $class, $suboption, $type;
	$final_path = str_replace("//", "/", str_replace("..", "", urldecode($path)));
	$file_array = file_list("$full_path/$final_path/");
	$pos = strrpos($final_path, "/");
	$previous_path = substr($final_path, 0, $pos); //previous path for the go back button

	echo "<br><img border=\"0\" src=\"graphics/folder_open.gif\" width=\"16\" height=\"16\">&nbsp;<span class=text><b>$rootpath$final_path</b></span>\n";
	echo "<table width=\"75%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";

	if ($file_array == false) /* check if the dir is an array before we process it to foreach(); */
	{
		print "<tr><td width=\"18\" height=\"18\"><img border=\"0\" src=\"graphics/button_back.gif\" width=\"16\" height=\"16\"></td>
				<td colspan=3><span class=\"text\">";
				
		if ((($type == "classes") OR ($type == "student_dir")) AND ($previous_path == ""))
		{	//we need a different goback link when we are in classes or student_dir  and return path is empty
		print "<a href=\"index.php?option=filemanager&type=$type&suboption=dir_list&path=$previous_path&class=$class\">" . $sas_lang['goback'] . "</a></span></td></tr>\n"; /* we don't need a size for a directory */
		}
		else
		{
			print "<a href=\"index.php?option=filemanager&type=$type&suboption=$suboption&path=$previous_path&class=$class\">" . $sas_lang['goback'] . "</a></span></td></tr>\n";
		}
		echo "</table>\n";
		echo "<p><span class=text>" . $sas_lang['emptydir'] . "</span>\n";

	}
	else
	{
		if ($final_path != "")
		{
			print "<tr><td width=\"18\" height=\"18\"><a href=\"index.php?option=filemanager&suboption=$suboption&path=$previous_path&class=$class\">
					<img border=\"0\" src=\"graphics/button_back.gif\" width=\"16\" height=\"16\"></a></td>
					<td colspan=\"3\"><span class=\"text\">";
					
			if ((($type == "classes") OR ($type == "student_dir")) AND ($previous_path == ""))
			{	//we need a different goback link when we are in classes or student_dir  and return path is empty
			print "<a href=\"index.php?option=filemanager&type=$type&suboption=dir_list&path=$previous_path&class=$class\">" . $sas_lang['goback'] . "</a></span></td></tr>\n";
			}
			else
			{
			print "<a href=\"index.php?option=filemanager&type=$type&suboption=$suboption&path=$previous_path&class=$class\">" . $sas_lang['goback'] . "</a></span></td></tr>\n";
			}
			print "<tr><td colspan=\"4\">&nbsp;</td></tr>\n"; 
		}
		foreach ($file_array as $file_name)
		{
			$is_file = "$full_path$final_path/$file_name";
			$final_dir_name = urlencode($final_path); /* urlencode(); to prevent any broken links - decode on do_download(); */
			$final_file_name = urlencode($file_name);
			$file_size = filesize("$full_path/$final_path/$file_name");
			$final_file_size = file_size($file_size);

			if (is_dir($is_file))
			{
				//get the number of files ($file_count[0]) and directories ($file_count[1])
				$file_count = count_files_dirs($is_file."/") ;
				
				$student_name = "" ;
				if ($type == "student_dir") //get the pupil name when we list student dirs
				{
					$query1 = "SELECT name, class FROM $table_users WHERE id = '".$file_name."'";
					$result1 = mysql_query($query1) or trigger_error(mysql_error().'"<br>Query : "' . $query1 . '".',E_USER_WARNING); 
					if (mysql_num_rows($result1) > 0)
					{
						$student_name = mysql_result($result1, 0, "name");
					}
					else
					{
						//project?
						$query2 = "SELECT name FROM $table_classes WHERE dir_number = '".$file_name."'";
						$result2 = mysql_query($query2) or trigger_error(mysql_error().'"<br>Query : "' . $query2 . '".',E_USER_WARNING); 
						$student_name = mysql_result($result2, 0, "name");
					}
				}
				print "<tr><td width=\"18\" height=\"18\">";
				
				if(($file_count[0] == 0) AND ($file_count[1] == 0))
				{
				$delete_file_confirmation = str_replace("%object%", $file_name, $sas_lang['delete_file_confirmation']);
				print "<img border=\"0\" src=\"graphics/delete.gif\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\" width=\"16\" height=\"16\"
						   onClick=\"if(confirm('" . $delete_file_confirmation . "')) parent.location='index.php?option=filemanager&type=$type&path=$path&suboption=delete_dir&delete_dir=$path/$file_name&class=$class';\"></td>\n";
				}
				else
				{
				print "<img border=\"0\" src=\"graphics/delete.gif\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\" width=\"16\" height=\"16\"
						   onClick=\"alert('Directory is not empty!')\"></td>\n";
				}
				print "<td width=\"18\" height=\"18\"><a href=\"index.php?option=filemanager&type=$type&suboption=file_list&class=$class&path=$final_dir_name/$final_file_name\">
						<img border=\"0\" src=\"graphics/folder_closed.gif\" width=\"16\" height=\"16\"></a></td>
						<td colspan=\"2\"><span class=\"text\">
						<a href=\"index.php?option=filemanager&type=$type&suboption=file_list&class=$class&path=$final_dir_name/$final_file_name\">$file_name</a></span>
						<span class=\"link\"> ($file_count[0],$file_count[1])</span>&nbsp;
						<span class=\"text\"><b>$student_name</b>&nbsp;</td></tr>\n"; 
			}
		}
		echo "</table>\n";
	}
}

function count_files_dirs($dir)
//function to get the number of dirs and files
// "." and ".." are skipped, returns array (#dirs , #files)
{
$i = 0 ; //number of files
$j = 0 ; //number of dirs
	if (is_dir($dir)) 
	{
	   if ($dh = opendir($dir)) 
		{
		   while (($file = readdir($dh)) !== false) 
			{
				if((filetype($dir . $file) == "dir") AND ($file != ".") AND ($file != ".."))
				{
					$j++;
				}
				elseif(filetype($dir . $file) == "file")
				{
					$i++;
				}
			}
		   closedir($dh);
	   }
	}

return array($j,$i);
}	// end of the 'count_files_dirs()' function

function list_suspicious_files($target)
{
//function to scan media and studentpages directory for malicious executable files.
	global $sas_config;
	$count = 0 ;

	$exceptions = array (
		".",
		".."
	); //skip those
	$valid_types = explode(",", $sas_config['valid_file_extentions']);

	$sas_path = $sas_config['serverpath'] . $sas_config['user_path'] . "/";

	$dh = opendir($sas_path . $target);

	while (false !== ($file_name = readdir($dh)))
	{
		if (!in_array($file_name, $exceptions))
		{
			if (is_dir($sas_path . $target . "/" . $file_name))
			{
				// recurse subdirectory; call of function recursive
				$count1 = list_suspicious_files($target . "/" . $file_name);
				$count = $count + $count1;
			}
			else
				if (is_file($sas_path . $target . "/" . $file_name))
				{
					$tmp = explode(".", $file_name); //get the file extention.
					if (count($tmp) > 1) //if there is one entry , the files has no extention
					{
					$ext = array_pop($tmp);
					}
					else
					{
					$ext = "" ;
					}
					if ((!in_array(strtolower($ext), $valid_types)) AND ($ext != "")) //is it in the list?
					{
						print "<span class=text><b>" . $target . "/" . $file_name . "</b></span><br>";
						$count++ ; //raise the file count
					}
				}
		}
	}

	closedir($dh);
	return $count;

} // end of the 'list_suspicious_files()' function

if ($suboption == "new_directory")
{
	if (strpos($newdirectory, "../") === FALSE) //check if someone is trying to fool us.
	{
		$newdirectory = remove_special_characters($newdirectory); //replace special characters with underscore
		if (IsSet ($subpath))
		{
			$newdirectory = "$serverpath/$rootpath" . "$subpath/$newdirectory";
		}
		else
		{
			$newdirectory = "$serverpath/$rootpath/$newdirectory";
		}
		
		if (file_exists($newdirectory)) //if directory already exists, give popup with warning
		{
		   print "<script language=\"JavaScript\">alert( '$sas_lang[directory] $_POST[newdirectory] already exists!' ); </script>";
		}
		else
		{
			$perm = $sas_config['file_permissions'];
			mkdir($newdirectory, 0755);
			chmod($newdirectory, octdec($perm)); //chmod it with permissions stored in configuration table.
		}
	}
$suboption = "file_list" ; //go back to the files list
}

if ($suboption == "file_upload")
{
	if (IsSet ($_FILES["file"]["name"]))
	{
		$file_name = $_FILES["file"]["name"];
	}
	if (IsSet ($subpath))
	{
		$write_path = $rootpath . $subpath;
	}
	else
	{
		$write_path = $rootpath;
	}
	if (file_exists($serverpath."/".$write_path."/".$file_name)) 
	{
		//if file already exists, give popup with warning
		$msg = str_replace("%file_name%", $file_name, $sas_lang['file_exists']);
		print "<script language=\"JavaScript\">alert( '$msg' ); </script>";
	}
	else
	{
		// moveupload the file to $write_path, function is in core/common.inc.php
		$temp_file = $_FILES["file"]["tmp_name"]; //this is temporary uploaded file.	
		sas_move_uploaded_file($write_path, $file_name, $temp_file);
	}
	$suboption = "file_list" ; //go back to the files list
}

if ($suboption == "delete")
{
// the files to be deleted are stored in $delete_list array
	foreach ($delete_list as $delete_file)
	{	//delete the selected files

		if (strpos($delete_file, "../") === FALSE) //check if someone is trying to fool us.
		{
			if (isSet ($path))	//do we have path relative to the rootpath
			{
				$file_name = "$serverpath/$rootpath$path/$delete_file";
				$thumb = "$serverpath/$rootpath$path/zz_thumb_" . $delete_file;
			}
			else
			{
				$file_name = "$serverpath/$rootpath/$delete_file";
				$thumb = "$serverpath/$rootpath/zz_thumb_" . $delete_file;
			}
			
			if (file_exists($file_name)) //if the file exists, delete it too.
			{
				unlink($file_name);
			}
			
			if (file_exists($thumb)) //if the thumb exists, delete it too.
			{
				unlink($thumb);
			}
		}
	}
$suboption = "file_list" ; //go back to the files list
}

if ($suboption == "delete_dir")
{
	if (strpos($delete_dir, "../") === FALSE) //check if someone is trying to fool us.
	{
	$delete_dir = $sas_config['serverpath'] . $sas_config['user_path'] . "/" . $rootpath . $delete_dir ;
	rmdir($delete_dir);
	}
	
	if ((($type == "student_dir") OR ($type == "classes")) AND ($path == ""))
	{
	//we need a directory list here.
	$suboption = "dir_list" ;
	}
	else
	{
	$suboption = "file_list" ; //go back to the files list
	}
}

include ("interface/header.inc.php");
include ("interface/menubar.inc.php");
include ("interface/menustart.inc.php");
print "<span class=heading>" . $sas_lang['filemanager_menu'] . "</span><br><br>";
print "<span class=link><a href=index.php?option=filemanager&type=media_dir&suboption=file_list>" . $sas_lang['filemanager'] . "</a>\n
       <p><a href=index.php?option=filemanager&type=student_dir&suboption=dir_list>" . $sas_lang['student_pages'] . "</a><p>\n
	   <p><a href=index.php?option=filemanager&type=classes&suboption=dir_list>" . $sas_lang['classes'] . "</a><p>\n
	   <a href=index.php?option=filemanager&suboption=check>File check</a><br></span>\n";
include ("interface/menuend.inc.php");
include ("interface/pagestart.inc.php");

if (substr($access, 0, 1) != 1) //bit 1 off the accessrights
{
	print "<span class=\"heading\">" . $sas_lang['noaccess'] . "<br></span>\n";
	print "<span class=\"text\">" . $sas_lang['noaccess_introduction'] . "</span><p>\n";
	include ("interface/pageend.inc.php");
	include ("interface/footer.inc.php");
	exit;
}

print "<span class=\"heading\">" . $sas_lang['filemanager'] . "</span><br>\n";

if($type == "media_dir") 
{
		print "<span class=\"text\">".$sas_lang['filemanager_introduction']."</span><p>";
}

if ($suboption == "multiple_upload")
{
	$sess_id = session_id();
	print "<br><img border=\"0\" src=\"graphics/folder_open.gif\" width=\"16\" height=\"16\">&nbsp;<span class=text><b>$rootpath$path</b></span>\n";
	print "<p>
		<table>
		<tr><td><span class=\"heading\">" . $sas_lang['multiple_upload'] . ":</span></td></tr>
		<tr><td>
		<applet name=\"postlet\" code =\"Main.class\" archive =\"core/Postlet.jar\" width =\"600\" height =\"200\" mayscript>
		<param name = \"maxthreads\"		value = \"5\" />
		<param name =\"type\" value =\"application/x-java-applet;version=1.4\">
		<param name=\"language\" value =\"" . $sas_config['language'] . "\"/>
		<param name =\"destination\" value =\"" . $sas_config['url'] . "starnet/core/javaUpload.php?store_path=". $rootpath . $path . "&PHPsessid=" . $sess_id . "\">
		<param name = \"backgroundcolour\" value = \"16777215\" />
		<param name = \"tableheaderbackgroundcolour\" value = \"13160660\" />
		<param name = \"tableheadercolour\" value = \"0\" />
		<param name = \"fileextensions\" value = \"Image Files,jpg,gif,jpeg\" />
		<param name = \"warnmessage\" value = \"false\" />
		<param name = \"autoupload\" value = \"false\" />
		<param name = \"helpbutton\" value = \"false\" />
		<param name =\"endpage\" value =\"" . $sas_config['url'] . "starnet/index.php?option=filemanager&type=$type&class=$class&suboption=file_list&path=" . $path . "\">
		<param name = \"helppage\" value = \"http://www.postlet.com/help/\" />
		</applet>
		</td></tr>
		</table>";
	exit;
}

if ($suboption == "check")
{
	print "<span class=\"text\">" .  $sas_lang['file_check']."<p></span>\n";
	$count1 = list_suspicious_files("media");
	$count2 = list_suspicious_files("studentpages");

	if(($count1 == 0) AND ($count2 == 0))
	{
	print "<span class=\"text\"><b>" . $sas_lang['empty_list'] . "</b></span><p>\n";
	}
	exit;
}

if (($suboption == "file_list") OR ($suboption == "check_files")) 
{
?>
<script language="JavaScript" type="text/javascript">
function checkinput ( form )
{
   if (form.newdirectory.value == "") 
    {
    alert( "<?php echo $sas_lang['input_error'] ?>" );
    form.newdirectory.focus();
    return false ;
    }
  return true ;
}
</script>
<?php
	print "<form method=post enctype=\"multipart/form-data\" action=index.php?option=filemanager&suboption=file_upload&type=$type&path=$path&class=$class>\n";
	print "<input type=hidden name=subpath value=$path>\n";
	
	print "<span class=text>" . $sas_lang['uploadfile'] . ":</span><br><input type=file name=file size=40 class=textfield>\n
		   &nbsp;<input type=submit value=&nbsp;&nbsp;&nbsp;" . $sas_lang['save'] . " name=B1 class=savebutton></form>\n";
	
	print "<form method=post action=\"index.php?option=filemanager&type=$type&suboption=new_directory&path=$path&class=$class\" onsubmit=\"return checkinput(this);\">";
	print "<span class=text>" . $sas_lang['createdir'] . ":</span><br><input type=text name=newdirectory size=20 class=textfield>
		   &nbsp;<input type=submit value=&nbsp;&nbsp;&nbsp;" . $sas_lang['save'] . " name=B1 class=savebutton>";
	
	print "&nbsp;&nbsp;&nbsp;<input type=\"button\" value=\"&nbsp;" . $sas_lang['multiple_upload'] . "\" 
		onClick=\"parent.location='index.php?option=filemanager&type=$type&suboption=multiple_upload&path=$path&class=$class'\">\n";
	
	if (IsSet ($path))
	{
		print "<form method=post action=index.php?option=filemanager&path=$path>";
		print "<input type=hidden name=subpath value=$path>";
	}
	print "</form>";
}
	
if($type == "media_dir") 
{
	$full_path = "$serverpath/$media"; /* path to the media directory*/

	print "<table width=100%><tr><td valign=top width=30%>\n";
	generate_dir_list($path); /* get directory list for the path specified */
	generate_file_list($path); /* get  file list for the path specified */
	print "</td></tr></table>";
}

if ($type == "student_dir")
{
	print "<span class=\"text\">".$sas_lang['filemanager_groups_intro']."</span>";
	$full_path = "$serverpath/studentpages";
	print "<table width=100%><tr><td valign=top width=30%>\n";
	generate_dir_list($path); /* get directory list for the path specified */
	
	if ($suboption == "file_list")
	{
	generate_file_list($path); /* get  file list for the path specified */
	}
	print "</td></tr></table>";
	exit;
}

if ($type == "classes")
{
	print "<span class=\"text\">".$sas_lang['filemanager_classes_intro']."</span>";
	$full_path = "$serverpath/studentpages";

	if (isset ($class)) //if we have a class list the directories
	{
		$query = "SELECT name, project FROM $table_classes WHERE id = '".$class."' OR dir_number = '".$class."'"; //get the classname
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
		$class_name = stripslashes(mysql_result($result, 0, "name"));
		$is_project = mysql_result($result, 0, "project") ;
		
		if ($is_project == 1)
		{
			$project = "(" . $sas_lang['student_project'] . ")" ;
		}
		else
		{
			$project = "";
		}

		if ($suboption == "dir_list")
		{
			print "<table width=\"100%\"><tr><td valign=\"top\" width=\"30%\">";
			$final_path = str_replace("//", "/", str_replace("..", "", urldecode($path)));
			$file_array = file_list("$full_path/$final_path/");

			print "<br><span class=\"link\">$class_name </span><span class=\"text\"> $project</span>";
			if ($file_array == false)
			{
				print "<table width=\"75%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
				print "<tr><td width=18 height=18><a href=\"index.php?option=filemanager&type=$type\">
					   <img border=\"0\" src=\"graphics/button_back.gif\" width=\"16\" height=\"16\"></a></td>
					   <td colspan=2><span class=\"text\"><a href=\"index.php?option=filemanager&type=$type\">" . $sas_lang['goback'] . "</a></span></td>
					   <td></td></tr>\n";
				print "</table>";
				print "<p><span class=text>" . $sas_lang['emptydir'] . "</span>";

			}
			else
			{
				print "<table width=\"55%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
				if ($final_path != "")
					print "<tr><td width=18 height=18><a href=\"index.php?option=filemanager\">
						   <img border=\"0\" src=\"graphics/button_back.gif\" width=\"16\" height=\"16\"></a></td>
						   <td colspan=2><span class=\"text\"><a href=\"index.php?option=filemanager&type=$type\">" . $sas_lang['goback'] . "
						   </a></span></td><td></td></tr>\n"; 

				foreach ($file_array as $file_name)
				{
					$is_file = "$full_path/$final_path$file_name";
					$final_dir_name = urlencode($final_path);
					$final_file_name = urlencode($file_name);
					$file_size = filesize("$full_path/$final_path/$file_name");
					$final_file_size = file_size($file_size);
					if (is_dir($is_file))
					{
						//get the number of files ($file_count[0]) and directories ($file_count[1])
						$file_count = count_files_dirs($is_file."/") ;
						
						$query1 = "SELECT name, class FROM $table_users WHERE id = '".$file_name."'";
						$result1 = mysql_query($query1) or trigger_error(mysql_error().'"<br>Query : "' . $query1 . '".',E_USER_WARNING); 
						if (mysql_num_rows($result1) > 0)
						{
							$student_name = mysql_result($result1, 0, "name");
							$student_class = mysql_result($result1, 0, "class");
						}
						else
						{
							$student_name = "";
						}
						//check to see if the class exists, teacher can have multiple classes so check them too.
						if (($student_class == $class) OR (strpos($student_class, ','.$class) !== FALSE) OR (strpos($student_class, ','.$class.',') !== FALSE) OR (strpos($student_class, $class.',') !== FALSE))
						{
							print "<tr><td width=\"18\" height=\"18\">";
							
							if(($file_count[0] == 0) AND ($file_count[1] == 0))
							{
							$delete_file_confirmation = str_replace("%object%", $file_name, $sas_lang['delete_file_confirmation']);
							print "<img border=\"0\" src=\"graphics/delete.gif\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\" width=\"16\" height=\"16\"
									   onClick=\"if(confirm('" . $delete_file_confirmation . "')) parent.location='index.php?option=filemanager&type=$type&path=$path&suboption=delete_dir&delete_dir=$path/$file_name&class=$class';\"></td>";
							}
							else
							{
							print "<img border=\"0\" src=\"graphics/delete.gif\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\" width=\"16\" height=\"16\"
							   onClick=\"alert('Directory is not empty!')\"></td>\n";
							}

							print "<td width=\"18\" height=\"18\"><a href=\"index.php?option=filemanager&suboption=file_list&type=$type&class=$class&path=$final_dir_name/$final_file_name\"><img border=\"0\" src=\"graphics/folder_closed.gif\" width=\"16\" height=\"16\"></a></td>
									  <td width=\"100\"><span class=\"text\"><a href=\"index.php?option=filemanager&type=$type&class=$class&suboption=file_list&path=$final_dir_name/$final_file_name\">$file_name</a></span><span class=\"link\"> ($file_count[0],$file_count[1])</span></td>
									  <td><b><a href=\"index.php?option=filemanager&class=$class&type=$type&suboption=file_list&path=$final_dir_name/$final_file_name\">$student_name</a></b></td></tr>";
						}
					}
				}
				print "</table>\n";
			}
			print "</td></tr></table>";
		}
		elseif ($suboption == "file_list")
		{
			$query = "SELECT name, project FROM $table_classes WHERE id = '".$class."' OR dir_number = '".$class."'"; //get the classname
			$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
			$class_name = stripslashes(mysql_result($result, 0, "name"));
			$is_project = mysql_result($result, 0, "project") ;
		
				if ($is_project == 1)
				{
					$project = $sas_lang['student_project'] ;
				}
				else
				{
					$project = $class_name;
				}
						
			if (isset ($path))
			{
				$student_path = substr($path, 1);
				$query1 = "SELECT name FROM $table_users WHERE id = '".$student_path."'";
				$result1 = mysql_query($query1) or trigger_error(mysql_error().'"<br>Query : "' . $query1 . '".',E_USER_WARNING); 
				if (mysql_num_rows($result1) > 0)
				{
					$student_name = mysql_result($result1, 0, "name");
				}
				print "<p><b>&nbsp;&nbsp;$student_name ($project)</b><table width=100%><tr><td valign=top width=30%>";
				generate_dir_list($path);
				generate_file_list($path);
				print "</td></tr></table>";
			}
		}
	}
	print "<p><span class=\"link\">" . $sas_lang['student_directories'] . ":</span><p>\n";
	
	$query = "SELECT id, name, project, dir_number FROM $table_classes ORDER BY name"; //get the classes
	$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 

	if ($result)
	{
		while ($class_list = mysql_fetch_array($result))
		{
			$class_name = stripslashes($class_list[1]);
			if($class_list[2] == 1)
			{
				$class_id = $class_list[3] ;
			}
			else
			{
				$class_id = $class_list[0] ;
			}
			print "<img border=\"0\" src=\"graphics/user.gif\" width=\"16\" height=\"16\">
					&nbsp;<span class=link><a href=\"index.php?option=filemanager&type=$type&suboption=dir_list&class=$class_id\">$class_name</a></span><br>";
		}
	}
}
print "</form>";
?>