<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.5.00  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@hccnet.nl)
* Based on the Wizz Forum:
* Original Idea & PHP coding: Mike Kroger (mikek@icon.co.za),
* who granted permission to put Wizz forum uder the GNU GPL. 
* Forum module : 
* index.php: last changed 16/04/2007 by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

if (IsSet ($_GET['option']))
{
	$option = sanitize($_GET['option'], 20, 'A'); //remove html tags
}
else
{
	$option = "" ;
}
if (IsSet ($_GET['suboption']))
{
	$suboption = sanitize($_GET['suboption'], 20 , 'A');
}

//set forum tables
$table_forumtopics = $dbprefix . "m_forumtopics";
$table_forumuser = $dbprefix . "m_forumuser";
$table_forumreplies = $dbprefix . "m_forumreplies";
$table_forumcat = $dbprefix . "m_forumcat";

if ($suboption == "logout")
{
	session_unset();
	session_destroy();
}

if (IsSet ($_GET['forumid']))
{
	$forumid = intval($_GET['forumid']);
	//get the forum type
	$result = mysql_query("SELECT type, name FROM $table_forumcat WHERE cat_index = '" . $forumid . "'");
	
	if (mysql_num_rows($result) > 0) //what is the forum type
	{	
		$forum_title = mysql_result($result, 0, 1);
		if (mysql_result($result, 0, 0) == 1)	//type  1: pupil, 2: teacher , 3: public
		{
			$forum_type = "pupil" ;
		}
		elseif (mysql_result($result, 0, 0) == 2)
		{
			$forum_type = "teacher" ;
		}
		elseif (mysql_result($result, 0, 0) == 3)
		{
			$forum_type = "public" ;
		}
	}
	else
	{
		exit; // we are being fooled.
	}
}

if (($forum_type == "pupil") OR ($forum_type == "teacher")) //check which forum the user belongs to , pupil en teacher forum
{
	if (IsSet ($_SESSION['userid'])) //if a user is already logged in as teacher OR pupil
	{
		$userid = $_SESSION['userid'];
		
		$result = mysql_query("SELECT username FROM $table_users WHERE id = '$userid'");
		
		if (mysql_num_rows($result) > 0) //Does user exists?
		{
			$_SESSION['forum_username'] = mysql_result($result, 0); //get the username of the user
	
			if ($_SESSION['usertype'] == "student")
			{
				$_SESSION['type_of_forum'] = "pupil";
			}
			if ($_SESSION['usertype'] == "teacher")
			{
				$_SESSION['type_of_forum'] = "teacher";
			}
		}
		else
		{
			$_SESSION['type_of_forum'] = "public";
		}
	}
}

if ($forum_type == "public")	//public forum
{
	if (IsSet ($_SESSION['forum_username']))	//this is the username for the public forums
	{
		$result3 = mysql_query("SELECT cat_index FROM $table_forumuser WHERE username = '$_SESSION[forum_username]'");
	
		if (mysql_num_rows($result3) > 0) //found one                            
		{
			$user_forum = $forum_type;	//user belongs to public
		}
	}
}

load_language($cmsdir . '/', 'sn_forum'); //load language file
setlocale(LC_TIME, $sas_lang[forum_locale]); // used for date formatting

$MaxTopicBody = $sas_config['forum_max_topic_char'];
$MaxReplyBody = $sas_config['forum_max_reply_char'];

switch ($option)
{
	default :
		include ("$cmsdir/modules/sn_forum/forums.php"); //list all the forums
		break;

	case forum :
		include ("$cmsdir/modules/sn_forum/forum.php"); //list topics of forum selected
		break;

	case topicdetails :
		include ("$cmsdir/modules/sn_forum/forumtopicdetails.php"); //list topic details
		break;

	case login :
		include ("$cmsdir/modules/sn_forum/forumlogin.php"); //login page
		break;

	case stats :
		if ($forum_type == "public")	//only valid for public forum
		{
		include ("$cmsdir/modules/sn_forum/forumviewstats.php"); //view the stats for a user
		}
		break;

	case newacc :
		if ($forum_type == "public")	//only valid for public forum
		{
		include ("$cmsdir/modules/sn_forum/forumnewacc.php"); //register a new account form
		}
		break;

	case updateacc :
		if ($forum_type == "public")	//only valid for public forum
		{
		include ("$cmsdir/modules/sn_forum/forummodacc.php"); //update a new account form
		}
		break;

	case verifyacc :
		if ($forum_type == "public")	//only valid for public forum
		{
		include ("$cmsdir/modules/sn_forum/forumverifymodacc.php"); //modify the new account
		}
		break;

	case verifynewacc :
		if ($forum_type == "public")	//only valid for public forum
		{
		include ("$cmsdir/modules/sn_forum/forumverifynewacc.php"); //verify the new account
		}
		break;

	case reply :
		include ("$cmsdir/modules/sn_forum/forumreply.php"); //topic reply
		break;

	case postreply : //post the reply
		include ("$cmsdir/modules/sn_forum/forumpostreply.php");
		break;

	case newtopic :
		include ("$cmsdir/modules/sn_forum/forumnewtopic.php"); //new topic
		break;

	case postnewtopic :
		include ("$cmsdir/modules/sn_forum/forumpostnewtopic.php"); //post the new topic
		break;

	case emailinfo : //send lost password form
		if ($forum_type == "public")	//only valid for public forum
		{
		include ("$cmsdir/modules/sn_forum/forumemailinfo.php");
		}
		break;

	case emaildetails :
		if ($forum_type == "public")	//only valid for public forum
		{
		include ("$cmsdir/modules/sn_forum/forumemaildetails.php"); //send the password via email
		}
		break;

	case authdetails :
		include ("$cmsdir/modules/sn_forum/forumauthdetails.php"); //profile of user
		break;

	case search :
		include ("$cmsdir/modules/sn_forum/forumsearch.php"); //search the forum
		break;
}
?>