<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.6.00  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@hccnet.nl)
* Class pages module : 
*  user_login.php: last changed 01/04/2008  by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

//teacher
if (IsSet ($_REQUEST['fullname']))
{
	$fullname = $_REQUEST['fullname'];
	$fullname = sanitize($fullname, 60, 'S'); //remove html tags
}
if (IsSet ($_POST['username']))
{
	$username = $_POST['username'];
	$username = sanitize($username, 20, 'A'); //remove html tags
}
if (IsSet ($_POST['password']))
{
	$password = $_POST['password'];
	$password = sanitize($password, 10, 'S'); //remove html tags
}
if (IsSet ($_POST['class1']))
{
	$class1 = intval($_POST['class1']);
}
if (IsSet ($_REQUEST['new_class']))
{
	$new_class = intval($_REQUEST['new_class']);
}
if (IsSet ($_POST['email']))
{
	$email = $_POST['email'];
	$email = htmlspecialchars(strip_tags($email)); //remove html tags
}
if (IsSet ($_POST['check']))
{
	$check = intval($_POST['check']);
}
if (IsSet ($_POST['send_email']))
{
	$send_email = sanitize($_POST['send_email'], 80 , 'A');
}
if (IsSet ($_POST['invisible']))
{
	$invisible = intval($_POST['invisible']);
}
if (IsSet ($_GET['student_id']))
{
	$student_id = sanitize($_GET['student_id'], 5, 'A');
}

if (IsSet ($_REQUEST['option']))
{
	$option = $_REQUEST['option'];
	$option = htmlspecialchars(strip_tags($option)); //remove html tags
}

//student
if (IsSet ($_POST['title']))
{
	$title = sanitize($_POST['title'], 50 , 'S');
}
if (IsSet ($_POST['order']))
{
	$order = intval($_POST['order']);
}
$d = date("Y-m-d"); //todays date

if (IsSet ($_POST['newcontent']))
{
	$newcontent = sql_addslashes($_POST['newcontent']);
}

if ((IsSet ($option)) AND (($option == "userlogin") OR ($option == "save_new_password")))
{
	if (!verify_logon($_POST['user_username'], $_POST['user_password'], $option))
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"" . $sas_lang['login_error'] . "\");
			   window.location = 'index.php?page=$page&amp;section=$section' ;	
			   //-->
			   </script>";
	}
}
elseif (!IsSet ($_SESSION['userid']))
{
	if (IsSet ($_GET['username']))
	{
		$username = sanitize($_GET['username'], 20, 'A'); //remove html tags
	}

	if ($_GET['error'] == "true")
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"" . $sas_lang['password_change_problem'] . "\");
			   //-->
			   </script>";
	}
	elseif ($option == "new_password") //passwords reset
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"" . $sas_lang['password_need_change'] . "\");
			   //-->
			   </script>";
	}

print "<script type=\"text/javascript\">

/*<![CDATA[*/

function checkinput ( form )
{
    if (form.user_password.value == '') 
    {
    alert( \"".$sas_lang['input_error']."\" );
    form.user_password.focus();
    return false ;
    }
    if (form.password_new1.value == '') 
    {
    alert( \"".$sas_lang['input_error']."\" );
    form.password_new1.focus();
    return false ;
    }
    if (form.password_new1.value.length < 4) 
	{
    alert( \"".$sas_lang['password_length_error']."\" );
    form.password_new1.focus();
    return false ;
    }
	if (form.password_new2.value == '') 
    {
    alert( \"".$sas_lang['input_error']."\" );
    form.password_new2.focus();
    return false ;
    }
    if (form.password_new2.value.length < 4) 
	{
    alert( \"".$sas_lang['password_length_error']."\" );
    form.password_new2.focus();
    return false ;
    }
  return true ;
}
/*]]>*/

</script>";

	//present the login form
	$header = $sas_lang['login_text'] ;
	login_form ($option, $site_url."index.php?section=$section&amp;page=$page", $header) ;
}

if (IsSet ($_SESSION['usertype']))
{
	$usertype = $_SESSION['usertype'];
}
else
{
	$usertype = "";
}
if (IsSet ($_SESSION['userid']))
{
	$userid = $_SESSION['userid'];
}

if ($usertype == "student")
{
	include ("$cmsdir/modules/sn_studentpages/student.php");
}
if ($usertype == "teacher")
{
	include ("$cmsdir/modules/sn_studentpages/teacher.php");
}
if ($usertype == "admin")
{
	print "<script language='javascript'>window.location = '$cmsdir/index.php'</script>";
}
?>